//Team Deathmatch VScript
//Script by John Worden (MilkMaster72)
ClearGameEventCallbacks()
local logicPD = Entities.FindByName(null, "tdm_logic_pd")
local logicTimer = Entities.FindByName(null, "tdm_logic_timer")
local tdmText = Entities.FindByName(null, "tdm_text")
local winRed = Entities.FindByName(null, "tdm_win_red")
local winBlue = Entities.FindByName(null, "tdm_win_blue")
local gamerules = Entities.FindByName(null, "tdm_gamerules")
local music = Entities.FindByName(null, "tdm_overtime_music")
local countKills = false
local roundOver = false
local musicStart = false
local redScore = 0
local blueScore = 0

function OnGameEvent_teamplay_round_start(params) //Round start
{
    NetProps.SetPropInt(logicPD, "m_nMaxPoints", 99999)
}
function SetupFinished() //Setup finished
{
    countKills = true
}
function OnGameEvent_player_death(params) //Player death
{
    if (countKills == false)
    return

    local attackerPlayer = GetPlayerFromUserID(params.attacker)
    local victimPlayer = GetPlayerFromUserID(params.userid)

    if (attackerPlayer == null)
    return

    if (attackerPlayer.IsPlayer())
    {
        if (attackerPlayer.GetTeam() == 2 && victimPlayer.GetTeam() != 2) //IS RED
            {
                redScore++
                //NetProps.SetPropInt(logicPD, "m_nRedScore", redScore)
            }
        if (attackerPlayer.GetTeam() == 3 && victimPlayer.GetTeam() != 3) //IS BLUE
            {
                blueScore++
                //NetProps.SetPropInt(logicPD, "m_nBlueScore", blueScore)
            }
    }
}
function CompareScore() //Round is over, compare scores
{
    roundOver = true
    if (redScore > blueScore) //RED wins
        {
            roundOver = false
            countKills = false
            EntFireByHandle(winRed, "RoundWin", null, 0, null, null)
            NetProps.SetPropInt(gamerules, "m_bInOvertime", 0)
            if (music != null)
                EntFireByHandle(music, "volume", "0", 0, null, null)
        }
    else if (redScore < blueScore) //BLU wins
        {
            roundOver = false
            countKills = false
            EntFireByHandle(winBlue, "RoundWin", null, 0, null, null)
            NetProps.SetPropInt(gamerules, "m_bInOvertime", 0)
            if (music != null)
                EntFireByHandle(music, "volume", "0", 0, null, null)
        }
    else if (redScore == blueScore) //Overtime
        {
            NetProps.SetPropInt(gamerules, "m_bInOvertime", 1)
            if (musicStart == false)
            {
            if (music != null)
                EntFireByHandle(music, "playsound", "0", 0, null, null)
            musicStart = true
            }
        }
}
function Tick()
{
    NetProps.SetPropInt(logicPD, "m_nRedScore", redScore)
    NetProps.SetPropInt(logicPD, "m_nBlueScore", blueScore)
    if (roundOver == true)
        CompareScore()
}
__CollectGameEventCallbacks(this)